/**********
WinTreeGraph.cpp -> Windows Last Left Threaded Data Tree Graphics
This file will hold all the Graphics.
***********/

#include "WinTree.h" // WinTree1.h is 'ifndef' so wont be multipled defind

// Draws the gauge that graphically represents the number of tree members left out of the original number.
void
DrawMembersGauge(int cxChar, int cyChar, int iVertPos, HWND hwnd, TreeData* pTD)  {

   int iNumMemLeft ;
   HBRUSH   hBrush ;	 
	RECT     rectA;
   HDC      hdc;

   iNumMemLeft = pTD->FetchCurrentTreeMemberCount( );

   SetRect(&rectA, cxChar * 36, cyChar * (27 + iVertPos), cxChar * 88, cyChar * (28 +  iVertPos) );
	hBrush = CreateSolidBrush( RGB(255,0,0) );
	hdc = GetDC(hwnd) ;
	FillRect(hdc, &rectA, hBrush) ;
	ReleaseDC(hwnd, hdc) ;
	DeleteObject(hBrush);
	hBrush = CreateSolidBrush( RGB(0,0,0) );
	FrameRect(hdc, &rectA, hBrush) ;
	DeleteObject(hBrush);
	Rectangle(hdc, cxChar * (36 + iNumMemLeft) , cyChar * (27 + iVertPos), cxChar * 88, cyChar * (28 +  iVertPos) );             

	return ;
	}
	
// This function will get the current system time when a node is removed.
// This system time value can then be displayed on the users' interface.

void
PrintTimeStamp(HDC hdc,  TreeData* pTD, int& cxChar, int& cyChar, int& cxCaps) {

   TCHAR *szMonths[12] = {{"January\0"},{"February\0"},{"March\0"},{"April\0"},{"May\0"},{"June\0"},{"July\0"},
		{"August\0"},{"September\0"},{"October\0"},{"November\0"},{"December\0"}} ;
	TCHAR *szDays[7] = {{"Sunday\0"},{"Monday\0"},{"Tuesday\0"},{"Wednesday\0"},{"Thursday\0"},{"Friday\0"},{"Saturday\0"}} ;

	TCHAR szBuffer[20] ;	 
	int iDate ;

   SetTextAlign (hdc, TA_RIGHT | TA_TOP) ; 
  
	iDate =  (pTD->FetchTimeStampLNR().wDayOfWeek)  ;
   TextOut (hdc, (cxChar * 44)+cxCaps, cyChar * (13) , szDays[iDate], strlen( szDays[iDate] ) ) ;
	
	iDate =  (pTD->FetchTimeStampLNR().wDay)  ;
   TextOut (hdc, cxChar * 49, cyChar * 13, szBuffer, wsprintf( szBuffer, TEXT("%3d"), iDate ) ) ;

	iDate =  (pTD->FetchTimeStampLNR().wMonth) - 1 ;
   TextOut (hdc, (cxChar * 58)+cxCaps, cyChar * (13) , szMonths[iDate], strlen( szMonths[iDate] ) ) ;
   
	iDate =  (pTD->FetchTimeStampLNR().wYear)  ;
   TextOut (hdc, cxChar * 65, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%3d"), iDate ) ) ;


   TextOut (hdc, cxChar * 68, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%1s"), "@" ) ) ;

	iDate =  (pTD->FetchTimeStampLNR().wHour)  ;
   TextOut (hdc, cxChar * 71, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%2d"), iDate ) ) ;

   TextOut (hdc, cxChar * 72, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%1s"), ":" ) ) ;

	iDate =  (pTD->FetchTimeStampLNR().wMinute)  ;
   TextOut (hdc, cxChar * 75, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%3d"), iDate ) ) ;

	TextOut (hdc, cxChar * 76, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%1s"), ":" ) ) ;

	iDate =  (pTD->FetchTimeStampLNR().wSecond)  ;
   TextOut (hdc, cxChar * 79, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%3d"), iDate ) ) ;

	TextOut (hdc, cxChar * 83, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%s"), "and" ) ) ;

   iDate =  (pTD->FetchTimeStampLNR().wMilliseconds)  ;
   TextOut (hdc, cxChar * 87, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%3d"), iDate ) ) ;

   TextOut (hdc, cxChar * 105, cyChar * (13) , szBuffer, wsprintf( szBuffer, TEXT("%s"), "one thousand sec." ) ) ;

	SetTextAlign (hdc, TA_LEFT | TA_TOP) ;
	
	return ;
	}